初次體驗:nginx+php+fastcg+xcache+mysql+openx
本文安裝環境:
os:rh8 ,centos5
kernel:2.6
相關軟體包:libjpeg libpng freetype libxml2 zlib (這些可以用RPM包安裝,相應的開發包也裝上*-devel)
nginx0.6.31 http://sysoev.ru/nginx/nginx-0.6.31.tar.gz
pcre7.7 ftp://ftp.csx.cam.ac.uk/pub/soft ... cre/pcre-7.7.tar.gz
php5.2.6 http://www.php.net/get/php-5.2.6.tar.gz/from/this/mirror
mysql 5.0 我這裡用的壓縮版,直接解壓設置許可權使用的
xcache1.2.2 http://xcache.lighttpd.net/pub/Releases/1.2.2/xcache-1.2.2.tar.gz
php-fpm http://php-fpm.anight.org/downlo ... 6-fpm-0.5.8.diff.gz (注意5.0的PHP沒有相應的補丁包,php-fpm是為PHP打的一個FastCGI管理補丁,可以平滑變更php.ini配置而無需重啟php-cgi)
同時也可以安裝zend
openx2.4 http://download.openx.org/openx-2.4.6.tar.gz
nginx+php5+fastcgi+xcache+mysql 這套系統還可以安裝discuz+zend
安裝過程:一、mysql
shell> /usr/sbin/groupadd mysql
shell> /usr/sbin/useradd -g mysql mysql
shell> groupadd mysql
shell> useradd -g mysql mysql
shell> cd /usr/local
shell> gunzip < /PATH/TO/MYSQL-VERSION-OS.tar.gz | tar xvf -
shell> ln -s FULL-PATH-TO-MYSQL-VERSION-OS mysql
shell> cd mysql
shell> scripts/mysql_install_db --user=mysql
shell> chown -R root .
shell> chown -R mysql data
shell> chgrp -R mysql .
shell> bin/mysqld_safe --user=mysql &
複製代碼我這裡也是省事,沒有選擇編譯安裝,其實最主要是注意許可權問題。mysql啟動問題就不大。
二、PHP (本人在RH8上也安裝成功,就是相關的依賴比較多) shell>tar zxvf php-5.2.6.tar.gz
shell>gzip -cd php-5.2.6-fpm-0.5.8.diff.gz | patch -d php-5.2.6 -p1
shell>cd php-5.2.6/
shell>./configure --prefix=/usr/local/php5 --with-mysql=/usr/local/mysql --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir --enable-xml --disable-debug --enable-fastcgi --enable-fpm --enable-force-cgi-redirect --enable-mbstring --with-gd --with-openssl
shell>make && make install
shell>cp php.ini-dist /usr/local/php/etc/php.ini
複製代碼註:沒有php5.0 的php-fpm補丁包
參數可由自己定,php5卻需要安裝gd,libxml2,fastcgi,fpm,mbstring 對於memcache,xcache 可自行選擇
gd又依賴:jpeg,png,zlib,freetype,gd2
在編譯過程中有可能會遇到一些錯誤。
一般解決辦法為:升級rpm為最新的,並安裝相關的依賴包
下載源碼包安裝到其它目前,編譯時指定相關的目錄。
具體的情況可以多看./configure --help
三、xcache 給PHP加速(建議安裝)shell>tar zxvf xcache-1.2.2.tar.gz
shell>cd xcache-1.2.2/
shell>/usr/local/php5/bin/phpize
shell>./configure --with-php-config=/usr/local/php5/bin/php-config --enable-xcache
shell>make &&make install
複製代碼四、修改php.ini (可下載附件進行查看)sed -i 's#extension_dir = "./"#extension_dir = "/usr/local/webserver/php/lib/php/extensions/no-debug-non-zts-
20060613/" /usr/local/webserver/php/etc/php.ini
sed -i 's#display_errors = On#display_errors = Off#' /usr/local/webserver/php/etc/php.ini
複製代碼在未尾加入
zend_extension = /usr/local/webserver/php/lib/php/extensions/no-debug-non-zts-20060613/xcache.so
xcache.admin.user = "xcache"
; xcache.admin.pass = md5($yourpasswd)
xcache.admin.pass = "8e6867a5d05144cf4761d6481fc674a8"
xcache.cacher = On
xcache.shm_scheme = "mmap"
xcache.size = 32M
; cpu number (cat /proc/cpuinfo |grep -c processor)
xcache.count = 2
xcache.slots = 8k
xcache.ttl = 0
xcache.gc_interval = 0
xcache.var_size = 2M
; cpu number (cat /proc/cpuinfo |grep -c processor)
xcache.var_count = 2
xcache.var_slots = 8K
xcache.var_ttl = 0
xcache.var_maxttl = 0
xcache.var_gc_interval = 300
xcache.readonly_protection = Off
xcache.mmap_path = "/dev/zero"
複製代碼五、修改php-fpm.conf (可下載附件進行查看)
vi /usr/local/php5/etc/php-fpm.conf
用戶組及PHP目錄及,其它的一些信息可以根據自己的環境和需求來定
參考:
<?xml version="1.0" ?> <configuration> All relative paths in this config are relative to php's install prefix <section name="global_options"> Pid file <value name="pid_file">/usr/local/webserver/php/logs/php-fpm.pid</value> Error log file <value name="error_log">/usr/local/webserver/php/logs/php-fpm.log</value> Log level <value name="log_level">notice</value> When this amount of php processes exited with SIGSEGV or SIGBUS ... <value name="emergency_restart_threshold">10</value> ... in a less than this interval of time, a graceful restart will be initiated. Useful to work around accidental curruptions in accelerator's shared memory. <value name="emergency_restart_interval">1m</value> Time limit on waiting child's reaction on signals from master <value name="process_control_timeout">5s</value> Set to 'no' to debug fpm <value name="daemonize">yes</value> </section> <workers> <section name="pool"> Name of pool. Used in logs and stats. <value name="name">default</value> Address to accept fastcgi requests on. Valid syntax is 'ip.ad.re.ss:port' or just 'port' or '/path/to/unix/socket' <value name="listen_address">127.0.0.1:9000</value> <value name="listen_options"> Set listen(2) backlog <value name="backlog">-1</value> Set permissions for unix socket, if one used. In Linux read/write permissions must be set in order to allow connections from web server. Many BSD-derrived systems allow connections regardless of permissions. <value name="owner"></value> <value name="group"></value> <value name="mode">0666</value> </value> Additional php.ini defines, specific to this pool of workers. <value name="php_defines"> <value name="sendmail_path">/usr/sbin/sendmail -t -i</value> <value name="display_errors">0</value> </value> Unix user of processes <value name="user">www</value> Unix group of processes <value name="group">www</value> Process manager settings <value name="pm"> Sets style of controling worker process count. Valid values are 'static' and 'apache-like' <value name="style">static</value> Sets the limit on the number of simultaneous requests that will be served. Equivalent to Apache MaxClients directive. Equivalent to PHP_FCGI_CHILDREN environment in original php.fcgi Used with any pm_style. <value name="max_children">128</value> Settings group for 'apache-like' pm style <value name="apache_like"> Sets the number of server processes created on startup. Used only when 'apache-like' pm_style is selected <value name="StartServers">20</value> Sets the desired minimum number of idle server processes. Used only when 'apache-like' pm_style is selected <value name="MinSpareServers">5</value> Sets the desired maximum number of idle server processes. Used only when 'apache-like' pm_style is selected <value name="MaxSpareServers">250</value> </value> </value> Time limit on waiting execution of single request Should be used when 'max_execution_time' ini option does not terminate execution for some reason <value name="request_execution_timeout">31s</value> Set open file desc rlimit <value name="rlimit_files">51200</value> Set max core size rlimit <value name="rlimit_core">0</value> Chroot to this directory at the start <value name="chroot"></value> Chdir to this directory at the start <value name="chdir"></value> Redirect workers' stdout and stderr into main error log. If not set, they will be redirected to /dev/null, according to FastCGI specs <value name="catch_workers_output">yes</value> How much requests each process should execute before respawn. Useful to work around memory leaks in 3rd party libraries. For endless request processing please specify 0 Equivalent to PHP_FCGI_MAX_REQUESTS <value name="max_requests">51200</value> Comma separated list of ipv4 addresses of FastCGI clients that allowed to connect. Equivalent to FCGI_WEB_SERVER_ADDRS environment in original php.fcgi (5.2.2+) Makes sense only with AF_INET listening socket. <value name="allowed_clients">127.0.0.1</value> Pass environment variables like LD_LIBRARY_PATH All $VARIABLEs are taken from current environment <value name="environment"> <value name="HOSTNAME">$HOSTNAME</value> <value name="ATH">/usr/local/bin:/usr/bin:/bin</value> <value name="TMP">/tmp</value> <value name="TMPDIR">/tmp</value> <value name="TEMP">/tmp</value> <value name="OSTYPE">$OSTYPE</value> <value name="MACHTYPE">$MACHTYPE</value> <value name="MALLOC_CHECK_">2</value> </value> </section> </workers> </configuration>
複製代碼啟動php-cgi
/usr/local/php5/sbin/php-fpm start(stop)
《解決方案》
六、建立nginx運行的用戶及組
/usr/sbin/groupadd www -g 48
/usr/sbin/useradd -u 48 -g www www
php-fpm也用此用戶及組啟動
七、安裝nginx
tar zxvf pcre-7.7.tar.gz
cd pcre-7.7/
./configure
make && make install
cd ../
tar zxvf nginx-0.6.31.tar.gz
cd nginx-0.6.31/
./configure --user=www --group=www --prefix=/usr/local/nginx --with-http_stub_status_module --with-http_ssl_module
make && make install
編譯安裝速度超快。不需要像apache那樣漫長的等待,我這裡並沒有發生錯誤。呵
八、配置啟動nginx 配置fcgi
見附件
/usr/local/nginx/sbin/nginx
相關命令:
/usr/local/nginx/sbin/nginx -t 測試配置文件
/usr/local/nginx/sbin/nginx -v 查看相關版本
/usr/local/nginx/sbin/nginx ?c </path/to/config>為nginx指定配置文件
退出nginx
kill ?QUIT nginx_pid
重啟nginx
kill -HUP nginx-pid
笨方法就是:ps -ef |grep nginx 再kill pid
九、nginx啟動腳本(linuxtone.org) vi /etc/init.d/nginx
chkconfig --level 35 nginx on
#! /bin/sh
### BEGIN INIT INFO
# Provides: Nginx-php-fpm(fastcgi)
# Required-Start: $all
# Required-Stop: $all
# Default-Start: 3 5
# Default-Stop: 0 1 6
# Short-Description: Start and stop nginx-fcgi in external FASTCGI mode
# Description: Start and stop nginx-fcgi in external FASTCGI mode
# http://www.linxutone.org msn:
[email protected] ### END INIT INFO
set -e
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="nginx daemon"
NAME=nginx
DAEMON=/usr/local/nginx/sbin/$NAME
CONFIGFILE=/usr/local/nginx/conf/nginx.conf
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
# Gracefully exit if the package has been removed.
test -x $DAEMON || exit 0
d_start() {
/usr/local/php-fcgi/sbin/php-fpm start > /dev/null 2>&1
$DAEMON -c $CONFIGFILE || echo -n " already running"
}
d_stop() {
/usr/local/php-fcgi/sbin/php-fpm stop > /dev/null 2>&1
kill -QUIT `cat $PIDFILE` || echo -n " not running"
}
d_reload() {
/usr/local/php-fcgi/sbin/php-fpm reload > /dev/null 2>&1
kill -HUP `cat $PIDFILE` || echo -n " can't reload"
}
case "$1" in
start)
echo -n "Starting $DESC: $NAME"
d_start
echo "."
;;
stop)
echo -n "Stopping $DESC: $NAME"
d_stop
echo "."
;;
reload)
echo -n "Reloading $DESC configuration ..."
d_reload
echo "reloaded."
;;
restart)
echo -n "Restarting $DESC: $NAME"
d_stop
sleep 1
d_start
echo "."
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|restart|reload}" >&2
exit 3
;;
esac
exit 0
複製代碼十、nginx日誌處理腳本:
注意:不能直接刪除/.../access.log。#!/bin/sh
# This file run at 00:00
date=$(date -d "yesterday" +"%Y-%m-%d")
gzip -c /..../logs/access.log > /.../logs/${date}.log.gz
:>/..../logs/access.log
複製代碼再加入crontab 就可以了
還有另一個腳本:#!/bin/bash
# linuxtone.org
log_dir="/data/logs"
time=`date +%Y%m%d`
/bin/mkdir -p ${log_dir}/${date_dir} > /dev/null 2>&1
/bin/mv ${log_dir}/access_count.linxutone.org.log ${log_dir}/access_count.linuxtone.org.$time.log
kill -USR1 `cat /var/run/nginx.pid`
複製代碼十一、安裝openx2.4
解壓後放到/usr/local/nginx/html目錄。
設置許可權 chown www:www -R openx
chmod 777 -R openx/var
在瀏覽器里輸入http://192.168.19.60/openx
就可以安裝了,圖形的很好安裝
《解決方案》
linux環境是什麼???